//+------------------------------------------------------------------+
//|                                                  price zones.mq4 |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window

extern int    StepPips          = 100;
extern int    SubLevels         = 1;
extern bool   showZones         = true;
extern bool   showLines         = true;
extern bool   showPrices        = true;
extern int    pricesShift       = -40;
extern color  zoneColor         = C'233,233,233';
extern color  LevelColor        = DimGray;
extern int    LevelLineWidth    = 1;
extern int    LevelLineStyle    = STYLE_SOLID;
extern color  SubLevelColor     = DimGray;
extern int    SubLevelLineWidth = 1;
extern int    SubLevelLineStyle = STYLE_DOT;
extern color  pricesColor       = DimGray;
extern string indicatorUniqueID = "priceZones";

//
//
//
//
//

extern bool alertsOn        = false;
extern int  alertsPrice     = PRICE_CLOSE;
extern bool alertsOnCurrent = true;
extern bool alertsMessage   = true;
extern bool alertsSound     = false;
extern bool alertsEmail     = false;

//
//
//
//
//

int Step;
int totalLevels = 0;
int totalPrices = 0;
double Prices[];
double SubLevelStep;
string ShortName;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()   { ShortName = indicatorUniqueID+"-"; return(0); }
int deinit() { clearObjects();                    return(0); }
void clearObjects()
{
   string lookFor       = ShortName;
   int    lookForLength = StringLen(lookFor);
   for (int i = ObjectsTotal(); i>= 0; i--)
      {
         string name  = ObjectName(i); if (StringSubstr(name,0,lookForLength)==lookFor) ObjectDelete(name);
      }  
   totalLevels = 0;
   totalPrices = 0;
      ArrayResize(Prices,0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   datetime last;
   datetime first;
   double   price;
   
   
   if (totalLevels>0)
      {
         first = ObjectGet(ShortName+"1",OBJPROP_TIME1);
         last  = ObjectGet(ShortName+"1",OBJPROP_TIME2);
      }
      if (Digits==3 || Digits==5)
            Step = StepPips*10;
      else  Step = StepPips;
      if (SubLevels>0)  SubLevelStep = Step/(SubLevels+1);
      
   //
   //
   //
   //
   //
         
   if (first != Time[Bars-1] || last != Time[0])
   {
         clearObjects();
         double lowPrice  = Low[ iLowest (NULL,0,MODE_LOW ,0,0)];
         double highPrice = High[iHighest(NULL,0,MODE_HIGH,0,0)];
         double low;
         double high;
         double current;
         
         //
         //
         //
         //
         //
         
            low     = MathFloor(lowPrice/(Step*Point))*Step*Point;
            high    = MathCeil(highPrice/(Step*Point))*Step*Point;
            current = low;
            
         // 
         //       
         //
         //
         //
         
         string name; 
         while(current<=high)
         {
            if (showZones)
            {
               totalLevels++;  name = StringConcatenate(ShortName,totalLevels);
                  ObjectCreate(name,OBJ_RECTANGLE,0,Time[Bars-1],current,Time[0],current+(Step*Point));
                     ObjectSet(name,OBJPROP_COLOR,zoneColor);
                     ObjectSet(name,OBJPROP_BACK,true);
            }                     
                  
            //
            //
            //
            //
            //
                              
            if (showLines)
            {
               totalLevels++;  name = StringConcatenate(ShortName,totalLevels);
               price = setPrice(current);
                  ObjectCreate(name,OBJ_TREND,0,Time[Bars-1],price,Time[0],price);
                     ObjectSet(name,OBJPROP_COLOR,LevelColor);
                     ObjectSet(name,OBJPROP_RAY,false);
                     ObjectSet(name,OBJPROP_BACK,true);
                     ObjectSet(name,OBJPROP_WIDTH,LevelLineWidth);
                     ObjectSet(name,OBJPROP_STYLE,LevelLineStyle);
               totalLevels++;  name = StringConcatenate(ShortName,totalLevels);
               price = setPrice(current+(Step*Point));
                  ObjectCreate(name,OBJ_TREND,0,Time[Bars-1],price,Time[0],price);
                     ObjectSet(name,OBJPROP_COLOR,LevelColor);
                     ObjectSet(name,OBJPROP_RAY,false);
                     ObjectSet(name,OBJPROP_BACK,true);
                     ObjectSet(name,OBJPROP_WIDTH,LevelLineWidth);
                     ObjectSet(name,OBJPROP_STYLE,LevelLineStyle);

               //
               //
               //
               //
               //
               
               if (SubLevelStep != 0)                     
               {
                  for (int l=1; l<=SubLevels; l++)
                  {
                     totalLevels++;  name = StringConcatenate(ShortName,totalLevels);
                     price = setPrice(current+(SubLevelStep*l*Point));
                     ObjectCreate(name,OBJ_TREND,0,Time[Bars-1],price,Time[0],price);
                        ObjectSet(name,OBJPROP_COLOR,SubLevelColor);
                        ObjectSet(name,OBJPROP_RAY,false);
                        ObjectSet(name,OBJPROP_BACK,true);
                        ObjectSet(name,OBJPROP_WIDTH,SubLevelLineWidth);
                        ObjectSet(name,OBJPROP_STYLE,SubLevelLineStyle);
                  }
                  for (l=1; l<=SubLevels; l++)
                  {
                     totalLevels++;  name = StringConcatenate(ShortName,totalLevels);
                     price = setPrice(current+((SubLevelStep*l+Step)*Point));
                     ObjectCreate(name,OBJ_TREND,0,Time[Bars-1],price,Time[0],price);
                        ObjectSet(name,OBJPROP_COLOR,SubLevelColor);
                        ObjectSet(name,OBJPROP_RAY,false);
                        ObjectSet(name,OBJPROP_BACK,true);
                        ObjectSet(name,OBJPROP_WIDTH,SubLevelLineWidth);
                        ObjectSet(name,OBJPROP_STYLE,SubLevelLineStyle);
                  }                        
               }
            }

            //
            //
            //
            //
            //
            
            if (showPrices && (showLines || showZones))
            {
               totalLevels++;  name = StringConcatenate(ShortName,totalLevels);
                  ObjectCreate(name,OBJ_TEXT,0,barTime(-pricesShift),current);
                     ObjectSet(name,OBJPROP_COLOR,pricesColor);
                     ObjectSet(name,OBJPROP_BACK,true);
                     ObjectSetText(name,DoubleToStr(current,Digits),7,"Arial",pricesColor);
               totalLevels++;  name = StringConcatenate(ShortName,totalLevels);
                  ObjectCreate(name,OBJ_TEXT,0,barTime(-pricesShift),current+(Step*Point));
                     ObjectSet(name,OBJPROP_COLOR,pricesColor);
                     ObjectSet(name,OBJPROP_BACK,true);
                     ObjectSetText(name,DoubleToStr(current+(Step*Point),Digits),7,"Arial",pricesColor);

               //
               //
               //
               //
               //
               
               if (SubLevelStep != 0)                     
               {
                  for (l=1; l<=SubLevels; l++)
                  {
                     totalLevels++;  name = StringConcatenate(ShortName,totalLevels);
                        ObjectCreate(name,OBJ_TEXT,0,barTime(-pricesShift),current+(SubLevelStep*l*Point));
                           ObjectSet(name,OBJPROP_COLOR,pricesColor);
                           ObjectSet(name,OBJPROP_BACK,true);
                           ObjectSetText(name,DoubleToStr(current+(SubLevelStep*l*Point),Digits),7,"Arial",pricesColor);
                  }                           
                  for (l=1; l<=SubLevels; l++)
                  {
                     totalLevels++;  name = StringConcatenate(ShortName,totalLevels);
                        ObjectCreate(name,OBJ_TEXT,0,barTime(-pricesShift),current+((SubLevelStep*l+Step)*Point));
                           ObjectSet(name,OBJPROP_COLOR,pricesColor);
                           ObjectSet(name,OBJPROP_BACK,true);
                           ObjectSetText(name,DoubleToStr(current+((SubLevelStep*l+Step)*Point),Digits),7,"Arial",pricesColor);
                  }                           
               }
            }
            current += (Step*2*Point);
         }
   }

   //
   //
   //
   //
   //

   if (alertsOn)
   {
      if (alertsOnCurrent)
            int i = 0;
      else      i = 1;            
      double pricec = iMA(NULL,0,1,0,MODE_SMA,alertsPrice,i);
      double pricep = iMA(NULL,0,1,0,MODE_SMA,alertsPrice,i+1);
      
      //
      //
      //
      //
      //
      
      for (i=0; i<totalPrices; i++)
      {
         bool crossedDown = false;
         bool crossedUp   = false;
            if (Prices[i]>pricec && Prices[i]<pricep) crossedDown = true;
            if (Prices[i]<pricec && Prices[i]>pricep) crossedUp   = true;
            if (crossedDown) { doAlert("Level "+DoubleToStr(Prices[i],Digits)+" crossed down"); break; }
            if (crossedUp)   { doAlert("Level "+DoubleToStr(Prices[i],Digits)+" crossed up");   break; }
      }
   }

   return(0);
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

int barTime(int a)
{
   if(a<0)
         return(Time[0]+Period()*60*MathAbs(a));
   else  return(Time[a]);   
}
double setPrice(double price)
{
   totalPrices++; if (ArraySize(Prices) < totalPrices) ArrayResize(Prices,totalPrices);
   
   //
   //
   //
   //
   //
   
   double normalizedPrice = NormalizeDouble(price,Digits);
         Prices[totalPrices-1] = normalizedPrice;
   return(normalizedPrice);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," price zonse ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"price zones "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}